# include	<stdio.h>
# include	<stdlib.h>
# include	<malloc.h>
# ifdef MSDOS
# include	<conio.h>
# else
# define getch() (getc(stdin))
# define putch(c) (putc(c, stdout))
# endif /* MSDOS */
/* # include	"vcrplus.h" */
# include	"misc.h"
# include	"b3.h"
# include	"fnc7.h"
# include	"ileave.h"
# include	"scramble.h"


long	debug = 0;


static int	dscan( int channel, int month, int year, int starttime );
static void	IncD( int *day, int *month, int *year);
static int	process( int ch, int d, int m, int y, int start, int duration );
static int	prompt( char buffer[], int i, int d_array[], int index,
					int start );
extern int	cmp( const void *a, const void *b );


int
main( int argc, char *argv[] )
{
	char	buffer[50];
	int	step;
	int	day_today = 1, month_today = 1, year_today = 95;
	int	channel = 21, starttime = 1800, duration = 30;
	int	tmp;

	while (1) {
		printf("Day [%d]? ", day_today);
		fgets(buffer, sizeof buffer, stdin);
		if (buffer[0] == 'q' || buffer[0] == 'Q')
			writeout();
		else if (buffer[0] != '\n')
			day_today = atoi(buffer);

		printf("Month [%d]? ", month_today);
		fgets(buffer, sizeof buffer, stdin);
		if (buffer[0] == 'q' || buffer[0] == 'Q')
			writeout();
		else if (buffer[0] == '-')
			continue;	/* restart while loop at "Day?" */
		else if (buffer[0] != '\n')
			month_today = atoi(buffer);

		printf("Year [%d]? ", year_today);
		fgets(buffer, sizeof buffer, stdin);
		if (buffer[0] == 'q' || buffer[0] == 'Q')
			writeout();
		else if (buffer[0] == '-')
			continue;	/* restart while loop at "Day?" */
		else if (buffer[0] != '\n')
			year_today = atoi(buffer);

		while (1) {
			printf("Channel [%d]? ", channel);
			fgets(buffer, sizeof buffer, stdin);

			if (buffer[0] == 'q' || buffer[0] == 'Q')
				writeout();
			else if (buffer[0] == '-')
				break;
			else if (buffer[0] != '\n')
				channel = atoi(buffer);

			while (1) {
				printf("Start [%04d]? ", starttime);
				fgets(buffer, sizeof buffer, stdin);

				if (buffer[0] == 'q' || buffer[0] == 'Q')
					writeout();
				else if (buffer[0] == '-')
					break;
				else if (buffer[0] != '\n')
					starttime = atoi(buffer);

				while (1) {
					step = 0;
					duration = dscan(channel, month_today, year_today, starttime);

					if (duration == 0)
						break;

					if (duration < 0)
						duration = -duration;

					step = process(channel, day_today,
						month_today, year_today,
						starttime, duration);

					if (step) {
						/* get ready for next programme */
						tmp = end_time(starttime, duration);

						if (tmp < starttime)
							IncD(&day_today, &month_today, &year_today);

						starttime = tmp;
					}

					putchar('\n');
				}
			}
		}
	}

	return 0;
}


static void
IncD( int *day, int *month, int *year)
{
	static int monthlen[] = { 31,29,31,30,31,30,31,31,30,31,30,31 };

	if (++(*day) > monthlen[(*month)-1]) {
		*day = 1;

		if (++(*month) > 12) {
			*month = 1;

			if (++(*year) > 99)
				*year = 0;
		}
	}
	else if ((*day) == 29 && (*month) == 2 && ((*year) & 0x03) != 0) {
		/* not a leap year */
		/* this test fails in year 2100,2200,2300,2500 etc :-) */
		*day = 1;
		*month = 3;
	}

	return;
}


# define	HISTORY		12

static int
dscan( int channel, int month, int year, int start )
{
	char	buffer[20];
	int	index, i, nc, chr, edit, done;
	int	d_array[HISTORY];
	int	duration;

	index = set_dlist(d_array, HISTORY, channel, month, year, start);
	
	if (index)
		qsort(d_array, index, sizeof( int ), cmp);

/*	i = index;	*/	/* start beyond end of list */
	i = 0;			/* start at beginning of list */
	done = 0;

	do {
		nc = prompt(buffer, i, d_array, index, start);
		chr = edit = 0;

		while (chr != '\r') {
			switch (chr = getch()) {
			case '\b':
				if (nc) {
					putch('\b');
					putch(' ');
					putch('\b');
					buffer[--nc] = '\0';
					edit = 1;
				}

				break;

			case '\n':
				chr = '\r';
				/* fall thru */

			case '\r':
				putch(buffer[nc++] = ( char) chr);
				done = 1;
				break;

			case 0x1B:
				/* escape */
				i = index;
				putch(chr = '\r');	/* leave inner loop */
				break;

			case '\0':
				/* special character */
				switch (chr = getch()) {
				case 0x48:
					/* up arrow */
					if (i) {
						i--;

						/* leave inner loop */
						putch(chr = '\r'); 
						edit = 0;
					}
					else
						putch('\a');

					break;

				case 0x50:
					/* down arrow */
					if (i < index) {
						i++;

						/* leave inner loop */
						putch(chr = '\r');
						edit = 0;
					}
					else
						putch('\a');

					break;

				default:
					putch('\a');
					chr = 0;
				}

				break;

			default:
				/* any char */
				if (edit == 0) {
					prompt(buffer, i = index, NULL, index, start);
					nc = 0;
				}

				buffer[nc++] = ( char ) chr;
				putch(chr);
				edit = 1;
			}
		}

		if (buffer[0] == 'q' || buffer[0] == 'Q') {
			putch('\n');
			writeout();
		}

		duration = atoi(buffer);

		if (edit == 0)
			duration = -duration;
	} while (done == 0);

	putch('\n');
	return duration;
}


static long	prevcode = 0;
static long	GetCode( void );
static int	StepOverQuery( void );

static int
process( int channel, int day_today, int month_today, int year_today,
		int starttime, int duration )
{
	char		buffer[50];
	int		day, rem, bot3;
	long		newspaper, top5;
	long		tblidx, s4_out;
	int		s5_out, bump, ret = 0;
	fnc		*fptr;

	/* entered by hand */
	/* get the  t  bits and the  c  bits */
	if ((tblidx = scanfor(starttime, duration)) < 0) {
		printf("\aSorry, no index known.\n");
# define NOINDEX
# ifdef NOINDEX
		newspaper = GetCode();

		if (newspaper) {
			/* find what top5 ought to be by reversing code */
			top5 = f1(newspaper, KEY001);
			bot3 = ( int )(top5 % 1000);
			top5 /= 1000;

		/*	printf("Top5 = %ld\tBot3 = %d\n", top5, bot3);	*/
			decode_bot3(bot3, &day, &rem);
		/*	printf("Day = %d\n", day); */

			if ((s5_out = makebump(top5) + rem) >= 32)
				s5_out -= 32;

			printf("Modulo = %d (%d)\n", get_modulo(s5_out), s5_out);

			if (day != day_today)
				printf("\aWarning: wrong day!\n");

			printf("New date? ");
			fgets(buffer, sizeof buffer, stdin);
			day = atoi(buffer);
			bot3 = encode_bot3(day, rem);
			newspaper = top5*1000 + bot3;
			newspaper = f1(newspaper, KEY002);
			printf("Code for day %d = %ld\n", day, newspaper);

			printf("Decoder handy? [Ny]? ");
			fgets(buffer, sizeof buffer, stdin);
			switch (buffer[0]) {
			case 'y':
			case 'Y':
				printf("Please decode:\n");
				    
				for (tblidx = 0; tblidx < 8; tblidx++) {
				    int modulo;
				    
				    for (modulo = 0; modulo <= 3; modulo++) {
					/* we only want s5_out really */
					interleave(tblidx, modulo, (&s4_out), (&s5_out));
					if ((rem = s5_out - makebump(top5)) < 0)
						rem += 32;

					bot3 = encode_bot3(day, rem);
					newspaper = top5*1000 + bot3;
					newspaper = f1(newspaper, KEY002);
					printf("   %ld", newspaper);
				    }
				    
				    putc('\n', stdout);
				}
			}
		}
# endif
		ret = StepOverQuery();
	}
	else {
		int	query = 0;

		interleave(tblidx, channel-1, (&s4_out), (&s5_out));
/*		printf("s4_out = %s\n", pr_s4out(s4_out)); */

		if (fptr = func7(s4_out, month_today, year_today, NULL)) {
			/* present the newspaper code */
			top5 = fptr->top5;

			if ((bump = makebump(top5)) != fptr->bump)
				printf("\aSuspicious bump!\n");

			if ((rem = s5_out - bump) < 0)
				rem += 32;

			bot3 = encode_bot3(day_today, rem);
			newspaper = top5*1000 + bot3;
			newspaper = f1(newspaper, KEY002);
			printf("Code %ld\n", newspaper);

			/* check all matches before deciding if this is new */
			do {
				if (( long ) fptr->start == starttime &&
				    ( long ) fptr->duration == duration)
					/* no need to re-register */
					return 1;

			} while	(fptr = func7(s4_out, month_today, year_today, fptr));

			query = 1;
		}
		else {
			newspaper = GetCode();

			if (newspaper == 0)
				/* don't step onwards */
				return 0;

			/* find what top5 ought to be by reversing code */
			top5 = f1(newspaper, KEY001);
			bot3 = ( int )(top5 % 1000L);
			top5 /= 1000;
		/*	printf("Top5 = %ld\tBot3 = %d\n", top5, bot3);	*/

			decode_bot3(bot3, &day, &rem);
		/*	printf("Day = %d\n", day);	*/

			if ((bump = makebump(top5) + rem) >= 32)
				bump -= 32;

			printf("Modulo = %d\n", get_modulo(bump));

			if (day != day_today) {
				printf("\aWarning: wrong day!\n");
				query = 1;
			}

		/*	printf("s5_out = %03ld, rem = %03d\n", s5_out, rem);	*/

			if ((bump = s5_out - rem) < 0)
				bump += 32;

			if (bump != makebump(top5)) {
				printf("\aSuspicious bump! (should be %d, I get %d)\n", bump, makebump(top5));
				query = 1;
			}

			printf("So: f(%ld,%d,%d) -> %s,%d\n",
					top5, month_today, year_today,
					pr_s4out(s4_out), bump);
		}

		if (query) {
			printf("Register [Yn]? ");
			fgets(buffer, sizeof buffer, stdin);
			switch (buffer[0]) {
			case 'y':
			case 'Y':
			case '\n':
				reg(newspaper, top5, bot3, channel,
					day_today, month_today, year_today,
					s4_out, s5_out, bump,
					starttime, duration);

				prevcode = 0;
				ret = 1;

			default:
				ret = StepOverQuery();
			}
		}
		else {
			reg(newspaper, top5, bot3, channel,
				day_today, month_today, year_today,
				s4_out, s5_out, bump,
				starttime, duration);

			prevcode = 0;
			ret = 1;
		}

		printf("Decoder handy? [Ny]? ");
		fgets(buffer, sizeof buffer, stdin);
		switch (buffer[0]) {
		case 'y':
		case 'Y':
			printf("Please decode:\n");
			    
			for (tblidx = 0; tblidx < 8; tblidx++) {
			    int modulo;
			    
			    for (modulo = 0; modulo <= 3; modulo++) {
				/* we only want s5_out really */
				interleave(tblidx, modulo, (&s4_out), (&s5_out));
				if ((rem = s5_out - makebump(top5)) < 0)
					rem += 32;

				bot3 = encode_bot3(day, rem);
				newspaper = top5*1000 + bot3;
				newspaper = f1(newspaper, KEY002);
				printf("   %ld", newspaper);
			    }
			    
			    putc('\n', stdout);
			}
		}
	}

	return ret;
}


static int
StepOverQuery( void )
{
	char buffer[20];

	printf("Step over [Yn]? ");
	fgets(buffer, sizeof buffer, stdin);
	switch (buffer[0]) {
	case 'y':
	case 'Y':
	case '\n':
		return 1;
	}

	return 0;
}

static long
GetCode( void )
{
	char	buffer[20];
	long	newspaper = prevcode;

	if (newspaper)
		printf("Code [%ld]? ", newspaper);
	else
		printf("Code? ");

	fgets(buffer, sizeof buffer, stdin);

	if (buffer[0] != '\n')
		prevcode = newspaper = atol(buffer);

	return newspaper;
}

int
prompt( char buffer[], int i, int d_array[], int index, int start )
{
	int	nc = 0;
	int	duration;

	fputs("\r                                                  \r", stdout);
	printf("Start %04d: Duration? ", start, stdout);

	if (i == index)
		/* don't prompt */
		buffer[0] = '\0';
	else {
		nc = sprintf(buffer, "%3d", duration = d_array[i]);
		printf("[End = %04d] %s", end_time(start, duration), buffer);
	}

	return nc;
}


int
cmp( const void *a, const void *b )
{

	return *(( int * ) a) - *(( int * ) b);
}
