# include	<stdio.h>
# include	<stdlib.h>
# include	<malloc.h>
# include	<string.h>

# include	"vcrplus.h"
# include	"fnc7.h"


long	debug = 0;


void	spr( fnc *fptr );
void	top5list( int month, int year );
void	splittop5list( int month, int year );
fnc	*findnext( fnc *fptr, int month, int year );
int	s4out_year_month( fnc *optr, fnc *fptr );
int	splittop5_year_month( fnc *optr, fnc *fptr );

static fnc	*head = NULL;

main()
{
	int	bump, month, year;
	fnc	*fptr, *prev;

	head = readtables();

	killduptop5();

	/* scan for identical 'top5' mapping to different 's4_out' */

	for (year = 93; year <= 95; year++)
		for (month = 1; month <= 12; month++)
			top5list(month, year);

	/* rearrange list into 'split top5' order */
	head = reorder7(splittop5_year_month);

	for (year = 93; year <= 95; year++)
		for (month = 1; month <= 12; month++)
			splittop5list(month, year);

	/* rearrange list into 's4_out' order */
	head = reorder7(s4out_year_month);

	prev = head;
	while (prev) {
		pr_rev(prev);
		putchar('\n');
		fptr = prev->next;

		while (fptr && fptr->s4_out == prev->s4_out) {
			pr_rev(fptr);
			putchar('\n');
			fptr = fptr->next;
		}

		prev = fptr;
		putchar('\n');
	}

	return 0;
}



void
top5list( int month, int year )
{
	fnc	*prev, *fptr;

	if ((prev = findnext(head, month, year)) == NULL)
		return;

	while (prev) {
		pr(prev);
		putchar('\n');
		fptr = findnext(prev->next, month, year);
		
		while (fptr && (fptr->top5 == prev->top5)) {
			if (fptr->s4_out != prev->s4_out ||
			    fptr->bump != prev->bump)
					printf("Clash:\t");

			pr(fptr);
			putchar('\n');
			fptr = findnext(fptr->next, month, year);
		}

		prev = fptr;
	}

	putchar('\n');
	return;
}

void
splittop5list( int month, int year )
{
	fnc	*prev, *fptr;

	if ((prev = findnext(head, month, year)) == NULL)
		return;

	while (prev) {
		spr(prev);
		putchar('\n');
		fptr = findnext(prev->next, month, year);
		
		while (fptr && (fptr->top5 == prev->top5)) {
			if (fptr->s4_out != prev->s4_out ||
			    fptr->bump != prev->bump)
					printf("Clash:\t");

			spr(fptr);
			putchar('\n');
			fptr = findnext(fptr->next, month, year);
		}

		prev = fptr;
	}

	putchar('\n');
	return;
}


fnc *
findnext( fnc *fptr, int month, int year )
{

	while (fptr && (fptr->month != month || fptr->year != year))
		fptr = fptr->next;

	return fptr;
}

int
s4out_year_month( fnc *optr, fnc *fptr )
{
	int ret;

	if ((ret = ( int )(optr->s4_out - fptr->s4_out)) == 0) {
		if ((ret = optr->year - fptr->year) == 0)
			ret = optr->month - fptr->month;
	}

	return ret;
}

int
splittop5_year_month( fnc *optr, fnc *fptr )
{
	int ret;

	if ((ret = ( int )(optr->top5%1000L - fptr->top5%1000L)) == 0) {
		if ((ret = ( int )(optr->top5/1000L - fptr->top5/1000L)) == 0) {
			if ((ret = optr->year - fptr->year) == 0)
				ret = optr->month - fptr->month;
		}
	}

	return ret;
}

void
spr( fnc *fptr )
{

	printf("decode7(%01ld %03ld,%02d,%02d) -> %s", fptr->top5/1000L, fptr->top5%1000L, fptr->month,
			fptr->year, pr_s4out(fptr->s4_out));

	return;
}
