# include	<stdio.h>
# include	<stdlib.h>
# include	<conio.h>

# include	"vcrplus.h"
# include	"swop.h"

struct pair {
	int	orig;
	int	a;
	split	new;
};

# define	NLIST	29
# define	MASK	0x3F9

/*
 * Patterns for Jan 1993
 */
struct pair list[NLIST] = {
		{ 1513, 83 },
		{ 1613, 58 },
		{ 1776, 91 },
		{ 1818, 315 },
		{ 1869, 66 },
		{ 2126, 74 },
		{ 2332, 11 },
		{ 2487, 18 },
		{ 2877, 26 },
		{ 3086, 3 },
		{ 3526, 90 },
		{ 3809, 59 },
		{ 4286, 51 },
		{ 4635, 43 },
		{ 5012, 355 },
		{ 5266, 10 },
		{ 5382, 50 },
		{ 5513, 107 },
		{ 5593, 283 },
		{ 5963, 98 },
		{ 6294, 115 },
		{ 7330, 955 },
		{ 7879, 19 },
		{ 7990, 2 },
		{ 8116, 970 },
		{ 9042, 27 },
		{ 9538, 963 },
		{ 9541, 34 },
		{ 9630, 155 }
};

static void	level1( long k1, int j1, int r1 );

static int	keyb = 0;


split
splitlong( long top )
{
	split	ret;

	ret.a = ( int ) (top / 1000);
	ret.b = ( int )((top / 100) % 10);
	ret.c = ( int )((top / 10) % 10);
	ret.d = ( int ) (top % 10 );
	return ret;
}


# ifdef UNSPLIT
long
# else
split
# endif
scramble4( split top, int d0, long key )
{
	int	f4, f3, f2, f1;
# ifdef UNSPLIT
	int	d4, d3, d2, d1;

	/* dismantle 'top' (d0 is already supplied) */
	d4 = ( int ) (top / 1000);
	d3 = ( int )((top / 100) % 10);
	d2 = ( int )((top / 10) % 10);
	d1 = ( int ) (top % 10 );
# ifdef DEBUG
	printf("(%d%d%d%d &", d4, d3, d2, d1);
# endif
# else	/* not UNSPLIT */
# define	d4	top.a
# define	d3	top.b
# define	d2	top.c
# define	d1	top.d
# endif	/* UNSPLIT or not */

	/* dismantle 'key' */
	f4 = ( int ) (key / 1000);
	f3 = ( int )((key / 100) % 10);
	f2 = ( int )((key / 10) % 10);
	f1 = ( int ) (key % 10);
# ifdef DEBUG
	printf("%d%d%d%d) ", f4, f3, f2, f1);
# endif

	do {
		/* long multiply 'f' * 'd' -> 'd' */
		d4 = (d4 + (d3*f1) + (d2*f2) + (d1*f3) + (d0*f4)) % 10 ;
		d3 = (d3 + (d2*f1) + (d1*f2) + (d0*f3)) % 10 ;
		d2 = (d2 + (d1*f1) + (d0*f2)) % 10 ;
		d1 = (d1 + (d0*f1)) % 10 ;

		/* allow ^C */
		if (kbhit()) keyb = getch();
/*	} while (d4 == 0);	*/
	} while (0);

# ifdef UNSPLIT
	/* reconstruct answer */
	return (1000L*d4) + (100L*d3) + (10L*d2) + d1;
# else
	return top;
# endif
}


long
combine( split val )
{

	return (1000L*val.a) + (100L*val.b) + (10L*val.c) + val.d;
}


int
main( int argc, char *argv[] )
{
	int	j1, r1;
	long	k1;

	for (r1 = 0; r1 < NLIST; r1++)
		list[r1].new = splitlong(( long ) list[r1].orig);

	for (k1 = 4915; k1 <= 9999L; k1++) {
		printf("%ld\r", k1);

		for (j1 = 0; j1 <= 9; j1++) {
			for (r1 = 0; r1 < 24; r1++) {
				level1(k1, j1, r1);
			}
		}
	}

	return 0;
}


static void
level1( long k1, int j1, int r1 )
{
	long	k2, k3, k4;
	int	j2, j3, j4;
	int	r2, r3;
	int	l, nwins;
	static int	best = 4;
# ifdef UNSPLIT
	long	val;
# else
	split	val;
# endif

# ifdef FULL
	   for (k2 = 0; k2 <= 9999L; k2++) {
	    for (j2 = 0; j2 <= 9; j2++) {
	     for (r2 = 0; r2 < 24; r2++) {
	      for (k3 = 0; k3 <= 9999L; k3++) {
	       for (j3 = 0; j3 <= 9; j3++) {
	        for (r3 = 0; r3 < 24; r3++) {
	         for (k4 = 0; k4 <= 9999L; k4++) {
	          for (j4 = 0; j4 <= 9; j4++) {
# else
	   { k2 = 0L;
	    { j2 = 0;
	     for (r2 = 0; r2 < 24; r2++) {
	      { k3 = 0L;
	       { j3 = 0;
		{ r3 = 0;
		 { k4 = 0L;
		  { j4 = 0;
# endif
			nwins = 0;

			for (l = 0; l < NLIST; l++) {
				val = permuteS(list[l].new, r1);
				val = scramble4(val, j1, k1);
				val = permuteS(val, r2);
# ifdef FULL
				val = scramble4(val, j2, k2);
				val = permute(val, r2);
				val = scramble4(val, j3, k3);
				val = permute(val, r3);
				val = scramble4(val, j4, k4);
# endif

				if ((combine(val) & MASK) == (list[l].a & MASK ))
					nwins++;
			}

			if (nwins >= best) {
				best = nwins;

				printf("\nr(%d)->s(%d,%ld)->r(%d) [%d wins]\n",
						r1, j1, k1, r2,
						nwins);
			}

			if (keyb == 0x1B) {
				printf("\nKilled at: r(%d)->s(%d,%ld)->r(%d)\n",
						r1, j1, k1, r2);

				exit(-1);
			}
	          }		/* j4 */
	         }		/* k4 */
	        }		/* r3 */
	       }		/* j3 */
	      }			/* k3 */
	     }			/* r2 */
	    }			/* j2 */
	   }			/* k2 */

	return;
}
