# include	<stdio.h>
# include	<stdlib.h>
# include	<malloc.h>
# include	<string.h>

# include	"vcrplus.h"
# include	"fnc7.h"

# define	SCAN

long	debug = 0;


void	pr( fnc *fptr );
void	pr_rev( fnc *fptr );
int	jan9394only( fnc *fptr );
int	s4out_year( fnc *aptr, fnc *bptr );
int	try( int n, int c, int c4val, int ashift, int wshift, int n1, int c1 );
void	scanner( fnc *head );

static fnc	*head = NULL;

main()
{
	fnc	*fptr;

	readtables();
	killduptop5();
	prune7(jan9394only);
	reorder7(s4out_year);
	head = s4pairsonly();

	fptr = head;
	while (fptr) {
		pr(fptr);
		if (fptr = fptr->next) {
			putchar('\t');
			pr(fptr);
			fptr = fptr->next;
		}
		putchar('\n');
	}

	scanner(head);
	return 0;
}

int
jan9394only( fnc *fptr )
{

	return (fptr->month == 1 && (fptr->year == 93 || fptr->year == 94));
}


int
s4out_year( fnc *aptr, fnc *bptr )
{
	int	ret;

	if ((ret = aptr->s4_out - bptr->s4_out) == 0)
		ret = aptr->year - bptr->year;

	return ret;
}

static long	findkey( int text, int twiddle, int result, int twiddle2 );
static int	crunch( int text, int twiddle, long key );
static int	dv( int n, int m );

# define	findtext	findkey

void
scanner( fnc *head )
{
	int	twiddle, twiddle2, count;
	int	result, result2, rtwiddle;
	int	tmp, tmp2;
	long	key, key2;
	fnc	*fptr;

	for (key = 1; key <= 99999; key += 2) {
		/* odd numbers only */
		if ((key % 10) == 5)
			/* ignore if divisible by 5 */
			continue;

		for (twiddle = 0; twiddle <= 9; twiddle++) {
		    /* encrypt the first top5 value of jan93 */
		    result = crunch(head->top5, twiddle, key);
		/*  rtwiddle = (twiddle*key)%10;	*/
		    for (rtwiddle = 0; rtwiddle <= 9; rtwiddle++) {
			/*
			 * Find the key and twiddle that would encrypt the
			 * first top5 value of jan94 to the same result
			 */
			for (twiddle2 = 0; twiddle2 <= 9; twiddle2++) {
				fptr = head->next;
				key2 = findkey(fptr->top5, twiddle2, result, rtwiddle);

				/* prove it */
				result2 = crunch(fptr->top5, twiddle2, key2);

				if (result2 != result)
					continue;
# ifdef SCAN
				/* now try next pair(s) */
				count = 0;
				while (fptr = fptr->next) {
					tmp = crunch(fptr->top5, twiddle, key);
					if ((fptr = fptr->next) == NULL)
						break;

					tmp2 = crunch(fptr->top5, twiddle2, key2);

					if (tmp == tmp2)
						count++;
				}
# else
				count = 1;
# endif

				if (count > 1) {
					printf("f(%d,%d,%ld) -> %d, "
					       "f(%d,%d,%ld) -> %d, ",
						     head->top5, twiddle, key, result,
						     head->next->top5, twiddle2, key2, result2
					);

					printf("Count = %d\n", count);
				}

				if (kbhit() && getch() == 0x1B)
					printf("Key = %ld\n", key);
			}
		    }
		}
	}

	return;
}

static long
findkey( int text, int twiddle, int result, int rtwiddle )
{
	int	t0, t1, t2, t3, t4;
	int	k0, k1, k2, k3, k4;
	int	r0, r1, r2, r3, r4;

	/* get characters of text */
	t0 = twiddle;
	t1 = text % 10;
	t2 = (text / 10) % 10;
	t3 = (text / 100) % 10;
	t4 = (text / 1000) % 10;

	/* get characters of result */
	r0 = rtwiddle;
	r1 = result % 10;
	r2 = (result / 10) % 10;
	r3 = (result / 100) % 10;
	r4 = (result / 1000) % 10;

	/* find key */
	k0 = dv(r0, t0);
	k1 = dv(r1 - k0*t1, t0);
	k2 = dv(r2 - k1*t1 - k0*t2, t0);
	k3 = dv(r3 - k2*t1 - k1*t2 - k0*t3, t0);
	k4 = dv(r4 - k3*t1 - k2*t2 - k1*t3 - k0*t4, t0);

	return k4*10000L + k3*1000L + k2*100L + k1*10L + k0;
}

static int
crunch( int text, int twiddle, long key )
{
	int	t0, t1, t2, t3, t4;
	int	k0, k1, k2, k3, k4;
	int	r0, r1, r2, r3, r4;

	/* get characters of text */
	t0 = twiddle;
	t1 = text % 10;
	t2 = (text / 10) % 10;
	t3 = (text / 100) % 10;
	t4 = (text / 1000) % 10;

	/* get characters of key */
	k0 = ( int )(key % 10);
	k1 = ( int )(key / 10) % 10;
	k2 = ( int )(key / 100) % 10;
	k3 = ( int )(key / 1000) % 10;
	k4 = ( int )(key / 10000) % 10;

	/* find result */
	/* r0 = (k0*t0) % 10; */
	r1 = (k1*t0 + k0*t1) % 10;
	r2 = (k2*t0 + k1*t1 + k0*t2) % 10;
	r3 = (k3*t0 + k2*t1 + k1*t2 + k0*t3) % 10;
	r4 = (k4*t0 + k3*t1 + k2*t2 + k1*t3 + k0*t4) % 10;

	return r4*1000 + r3*100 + r2*10 + r1;
}


static int
dv( int n, int m)
{

	n %= 10;
	if (n < 0) n += 10;
	if (m == 1) return n;
	else if (m == 9) return (n*9)%10;
	return (n*(10-m)) % 10;
}
