# include	<stdio.h>

# include	"swop.h"

typedef struct { char a, b, c, d; } swirl;

swirl rules[24] = {{ 1,2,3,4 }, { 1,2,4,3 }, { 1,4,2,3 }, { 4,1,2,3 },
		   { 1,3,2,4 }, { 1,3,4,2 }, { 1,4,3,2 }, { 4,1,3,2 },
		   { 3,1,2,4 }, { 3,1,4,2 }, { 3,4,1,2 }, { 4,3,1,2 },
		   { 2,1,3,4 }, { 2,1,4,3 }, { 2,4,1,3 }, { 4,2,1,3 },
		   { 2,3,1,4 }, { 2,3,4,1 }, { 2,4,3,1 }, { 4,2,3,1 },
		   { 3,2,1,4 }, { 3,2,4,1 }, { 3,4,2,1 }, { 4,3,2,1 }};


long
permute( long val, int rule )
{
	int	a = ( int )(val / 1000);
	int	b = ( int )((val / 100) % 10);
	int	c = ( int )((val / 10) % 10);
	int	d = ( int )(val % 10);
	int	result[5];
	swirl	swirl;
	
	if (rule >= 0 && rule < 24) {
		swirl = rules[rule];
		result[swirl.a] = a;
		result[swirl.b] = b;
		result[swirl.c] = c;
		result[swirl.d] = d;
	}
	else
		return -1;

	return result[1]*1000L + result[2]*100L + result[3]*10L + result[4];
}


split
permuteS( split val, int rule )
{
	int	result[5];
	swirl	swirl;
	
	if (rule >= 0 && rule < 24) {
		swirl = rules[rule];
		result[swirl.a] = val.a;
		result[swirl.b] = val.b;
		result[swirl.c] = val.c;
		result[swirl.d] = val.d;
	}

	val.a = result[1];
	val.b = result[2];
	val.c = result[3];
	val.d = result[4];
	return val;
}


# ifdef HARNESS
int
main()
{
	long	val = 1234L;
	int	i;

	for (i = 0; i < 24; i++)
		printf("%ld\n", permute(val, i));

	return 0;
}
# endif
